<?php

defined("_JEXEC") or die("Restricted Access");



 class plgFlexicontent_fieldsSigalleryuploader extends JPlugin{

     

    function plgFlexicontent_fieldsImage( &$subject, $params )

    {

        parent::__construct( $subject, $params );

        JPlugin::loadLanguage('plg_flexicontent_fields_sigalleryuploader', JPATH_ADMINISTRATOR);

    }

    

    

    function onDisplayField(&$field, $item)

    {



        if($field->field_type != 'sigalleryuploader'){

         return;

        }

        else{

        $field->html = "<label>Gallery Name</label>

        <input type='text' name='gallery' value='" . $field->value[0] . "' size='40'/><br/>";   

         $field->html .= 'Upload Zip File <input type="file" name="zip_file" id="zip_file">'; 

        }

    }

    

    

  

  public function onAfterSaveField(&$field, &$post, $file)

    {

        if($field->field_type != 'sigalleryuploader')

        {

            return;

        }

        global $mainframe;

        jimport("joomla.application.component.controller");

        jimport('joomla.filesystem.folder');

        jimport("joomla.filesystem.file");

        jimport('joomla.filesystem.archive');

        $gallery_name = JRequest::getVar('gallery',null, 'post');



        $file            = JRequest::getVar('zip_file','','FILES','ARRAY');

        $safe_name        = JFile::makeSafe($file['name']);

        

        // File validation

        if($file['name'] == "" && $field->parameters->get('dir_path') == "" && $gallery_name != null){

            return;

        }

        

        // Zip file validation

        if(JFile::getExt($file["name"]) != "zip"){

             return;

        }

               

        // Uploading the zip file in new temporary folder

        $path_to_tmp    = JPATH_SITE.DS."tmp" . DS . "tmp" .time()."_".rand();

        $des_zip        = $path_to_tmp.DS.$safe_name;

        

        if(!JFile::upload($file['tmp_name'], $des_zip)){

            return;

        }else{

            JFile::write($path_to_tmp . DS . "index.html", "<html><body bgcolor='#FFFFFF'></body></html>");

        }

        

        // Extracting the uploaded zip file to temporary folder

        if(!JArchive::extract($des_zip,$path_to_tmp)){

             return;

        }

        

        // Deleting the uploaded zip file as we have extracted its contents

        JFile::delete($des_zip);        

        $files_in_tmp     = JFolder::files($path_to_tmp, ".", false, false, array("index.html"));     

        // Validation for atlease one image file

        if(count($files_in_tmp) == 0){

            JFolder::delete($path_to_tmp);

            return;

        }

        

        // Checking for images only

        $valid_images    = array("jpeg","jpg","png","gif");

        foreach($files_in_tmp as $file_in_tmp){

            $files_in_tmp_type    = JFile::getExt($file_in_tmp);

            if(!in_array($files_in_tmp_type, $valid_images)){

                JFolder::delete($path_to_tmp);

                return;

            }

        }

        

        // Creating the new folder to move image



        $image_folder       = $field->parameters->get('dir_path');         

        $img_path           = JPATH_SITE . DS . $image_folder . DS . $gallery_name;

        if (!JFolder::exists($img_path)){

            JFolder::create($img_path);

            JFile::write($img_path . DS . "index.html", "<html><body bgcolor='#FFFFFF'></body></html>");

        }

        

        // Moving images files in new folder

        foreach($files_in_tmp as $file_in_tmp){

            

            JFile::move($path_to_tmp.DS.$file_in_tmp, $img_path.DS.$file_in_tmp);

        }               

        // Deleting the temporary folder

        JFolder::delete($path_to_tmp);

        $mainframe->enqueueMessage( "Images from file saved.");    

    }

} 

?>

